<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_OrderedPrice1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_OrderedPrice1 extends AbstractStructArrayBase
{
    /**
     * The ChildrenA
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_OrderedPrice[]
     */
    public $ChildrenA;
    /**
     * Constructor method for ArrayOfJPSOAP_OrderedPrice1
     * @uses ArrayOfJPSOAP_OrderedPrice1::setChildrenA()
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenA
     */
    public function __construct(array $childrenA = array())
    {
        $this
            ->setChildrenA($childrenA);
    }
    /**
     * Get ChildrenA value
     * @return \StructType\JPSOAP_OrderedPrice[]|null
     */
    public function getChildrenA()
    {
        return $this->ChildrenA;
    }
    /**
     * Set ChildrenA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenA
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice1
     */
    public function setChildrenA(array $childrenA = array())
    {
        foreach ($childrenA as $arrayOfJPSOAP_OrderedPrice1ChildrenAItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderedPrice1ChildrenAItem instanceof \StructType\JPSOAP_OrderedPrice) {
                throw new \InvalidArgumentException(sprintf('The ChildrenA property can only contain items of \StructType\JPSOAP_OrderedPrice, "%s" given', is_object($arrayOfJPSOAP_OrderedPrice1ChildrenAItem) ? get_class($arrayOfJPSOAP_OrderedPrice1ChildrenAItem) : gettype($arrayOfJPSOAP_OrderedPrice1ChildrenAItem)), __LINE__);
            }
        }
        $this->ChildrenA = $childrenA;
        return $this;
    }
    /**
     * Add item to ChildrenA value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice $item
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice1
     */
    public function addToChildrenA(\StructType\JPSOAP_OrderedPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_OrderedPrice) {
            throw new \InvalidArgumentException(sprintf('The ChildrenA property can only contain items of \StructType\JPSOAP_OrderedPrice, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ChildrenA[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildrenA
     */
    public function getAttributeName()
    {
        return 'ChildrenA';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
